#ifndef EFL_VG_GRADIENT_EO_HH
#define EFL_VG_GRADIENT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_gfx.eo.h"
#include "efl_gfx_gradient.eo.h"
#include "efl_gfx_stack.eo.h"
#include "efl_vg.eo.h"
#include "efl_vg_gradient.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_gfx.eo.hh"
#include "efl_gfx_gradient.eo.hh"
#include "efl_gfx_stack.eo.hh"
#include "efl_vg.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace vg { 
struct Gradient;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::vg::Gradient> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace vg { 
struct Gradient {
   static Eo_Class const* _eo_class()
   {
      return EFL_VG_GRADIENT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::vg::Gradient() const;
   operator ::efl::vg::Gradient&();
   operator ::efl::vg::Gradient const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Gradient,  ::efl::Gfx,  ::efl::VG,  ::efl::gfx::Gradient,  ::efl::gfx::Stack,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Gradient const ,  ::efl::Gfx const ,  ::efl::VG const ,  ::efl::gfx::Gradient const ,  ::efl::gfx::Stack const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace vg { 
struct Gradient : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::VG)
   , EO_CXX_INHERIT( ::efl ::gfx::Gradient)
   , EO_CXX_INHERIT( ::efl ::gfx::Stack)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Gradient( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Gradient(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Gradient(Gradient const& other) = default;
   Gradient(Gradient&& other) = default;
   Gradient& operator=(Gradient const& other) = default;
   Gradient& operator=(Gradient&& other) = default;
   Gradient()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Gradient( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Gradient(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_VG_GRADIENT_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Gradient,  ::efl::Gfx,  ::efl::VG,  ::efl::gfx::Gradient,  ::efl::gfx::Stack,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Gradient const ,  ::efl::Gfx const ,  ::efl::VG const ,  ::efl::gfx::Gradient const ,  ::efl::gfx::Stack const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Gradient) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Gradient>::value, "");
} } 
#include "efl_vg_gradient.eo.impl.hh"
#endif
